<?php
/**
* @version $Id: helper.php 266 2008-09-11 09:20:13Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once (JPATH_SITE.DS.'components'.DS.'com_mmsblog'.DS.'helpers'.DS.'route.php');
jimport('joomla.filesystem.file');

class modMMSBlogImagesHelper
{
	function &getList(&$params)
	{
		$db			=& JFactory::getDBO();

		$count    = (int) $params->get('count', 5);

		$where = modMMSBlogImagesHelper::buildWhere($params);

		$query = 'SELECT m.id, m.subject, m.account, m.uid, m.category,'
		. ' CASE WHEN CHAR_LENGTH(m.alias) THEN CONCAT_WS(":", m.id, m.alias) ELSE m.id END as slug,'
		. ' (SELECT a.id FROM #__mmsblog_media a WHERE a.msgid = m.id AND a.published = 1 AND a.type = \'IMAGE\' LIMIT 1) AS mediaid,'
		. ' (SELECT a.filename FROM #__mmsblog_media a WHERE a.msgid = m.id AND a.published = 1 AND a.type = \'IMAGE\' LIMIT 1) AS filename'
		. ' FROM #__mmsblog_item AS m'
		. ' LEFT JOIN #__mmsblog_account AS a ON a.id = m.account'
		. ' LEFT JOIN #__mmsblog_user AS u ON u.id = m.uid'
		. ' LEFT JOIN #__categories AS c ON c.id = m.category'
		. ' WHERE m.published = 1'
		. ' AND a.published = 1'
		. ' AND u.published = 1'
		. ' AND (c.published = 1 OR c.published IS NULL)'
		. ' AND (SELECT COUNT(*) FROM #__mmsblog_media a WHERE a.msgid = m.id AND a.published = 1 AND a.type = \'IMAGE\') > 0'
		. $where
		. ' ORDER BY m.ordering DESC';

		$db->setQuery($query, 0, $count);
		$rows = $db->loadObjectList();

		$i = 0;
		$lists	= array();
		foreach ($rows as $row)
		{
			$lists[$i]->link  = JRoute::_(MMSBlogHelperRoute::getItemRoute($row->slug, $row->account, $row->uid, $row->category));
			$lists[$i]->text  = htmlspecialchars($row->subject, ENT_QUOTES, 'UTF-8');
			$lists[$i]->image = JURI::root().'images/mmsblog/'.sprintf('%05d_%05d.%s', $row->id, $row->mediaid, strtolower(JFile::getExt($row->filename)));
			$lists[$i]->path  = JPATH_SITE.DS.'images'.DS.'mmsblog'.DS.sprintf('%05d_%05d.%s', $row->id, $row->mediaid, strtolower(JFile::getExt($row->filename)));
			$i++;
		}

		return $lists;
	}

	function buildWhere(&$params)
	{
		$category = (int) $params->get('category');
		$account  = (int) $params->get('account');
		$user     = (int) $params->get('user');
		$juser    =& JFactory::getUser();

		$where = array();
		if ($category) {
			$where[] = 'm.category = '.$category;
		}
		if ($account) {
			$where[] = 'm.account = '.$account;
		}
		if ($user) {
			$where[] = 'm.uid = '.$user;
		}

		$where[] = '(c.access <= '.(int)$juser->get('aid', 0) . ' OR c.access IS NULL)';

		return count($where) ? (' AND ' . implode(' AND ', $where)) : '';
	}
}
