<?php
/**
* @version $Id: mmsblog.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent( 'onSearch', 'botSearchMMSBloglinks' );
$mainframe->registerEvent( 'onSearchAreas', 'botSearchMMSBlogAreas' );

/**
 * @return array An array of search areas
 */
function &botSearchMMSBlogAreas() {
	static $areas = array(
		'mmsblog' => 'MMS Blog'
	);
	return $areas;
}

/**
* MMS Blog Search method
*
* The sql must return the following fields that are used in a common display
* routine: href, title, section, created, text, browsernav
* @param string Target search string
* @param string mathcing option, exact|any|all
* @param string ordering option, newest|oldest|popular|alpha|category
* @param mixed An array if the search it to be restricted to areas, null if search all
*/
function botSearchMMSBloglinks( $text, $phrase='', $ordering='', $areas=null )
{
	$db   =& JFactory::getDBO();
	$user =& JFactory::getUser();

	if (is_array( $areas )) {
		if (!array_intersect( $areas, array_keys( botSearchMMSBlogAreas() ) )) {
			return array();
		}
	}

	// load plugin params info
 	$plugin =& JPluginHelper::getPlugin('search', 'mmsblog');
 	$pluginParams = new JParameter( $plugin->params );

	$limit = $pluginParams->def( 'search_limit', 50 );

	$text = trim( $text );
	if ($text == '') {
		return array();
	}

	$wheres = array();
	switch ($phrase) {
		case 'exact':
			$wheres2 	= array();
			$wheres2[] 	= "LOWER(m.subject) LIKE '%$text%'";
			$wheres2[] 	= "LOWER(m.content) LIKE '%$text%'";
			$where 		= '(' . implode( ') OR (', $wheres2 ) . ')';
			break;

		case 'all':
		case 'any':
		default:
			$words 	= explode( ' ', $text );
			$wheres = array();
			foreach ($words as $word) {
				$wheres2 	= array();
		  		$wheres2[] 	= "LOWER(m.subject) LIKE '%$word%'";
				$wheres2[] 	= "LOWER(m.content) LIKE '%$word%'";
				$wheres[] 	= implode( ' OR ', $wheres2 );
			}
			$where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
			break;
	}

	switch ( $ordering )
	{
		case 'category':
			$order = 'c.title, m.subject';
			break;
		case 'oldest':
			$order = 'm.created, m.subject';
			break;
		case 'newest':
			$order = 'm.created DESC, m.subject';
			break;
		case 'popular':
		case 'alpha':
		default:
			$order = 'm.subject';
	}

	$searchMMSBlog = JText::_( 'MMS Blog' );

	$query = 'SELECT m.subject AS title, m.created, m.subject AS text, m.account, m.uid, m.category, CONCAT_WS( \' / \',\''.$searchMMSBlog.'\', c.title) AS section, 2 AS browsernav,'
	. ' CASE WHEN CHAR_LENGTH(m.alias) THEN CONCAT_WS(":", m.id, m.alias) ELSE m.id END as slug'
	. ' FROM #__mmsblog_item AS m'
	. ' LEFT JOIN #__mmsblog_account AS a ON a.id = m.account'
	. ' LEFT JOIN #__mmsblog_user AS u ON u.id = m.uid'
	. ' LEFT JOIN #__categories AS c ON c.id = m.category'
	. ' WHERE ('.$where.')'
	. ' AND m.published = 1'
	. ' AND a.published = 1'
	. ' AND u.published = 1'
	. ' AND (c.published = 1 OR c.published IS NULL)'
	. ' AND (c.access <= '.(int)$user->get('aid', 0) . ' OR c.access IS NULL)'
	. ' ORDER BY '.$order;

	$db->setQuery( $query, 0, $limit );
	$rows = $db->loadObjectList();

	JLoader::import('components.com_mmsblog.helpers.route', JPATH_SITE);
	foreach($rows as $key => $row) {
		$rows[$key]->href = MMSBlogHelperRoute::getItemRoute($row->slug, $row->account, $row->uid, $row->category);
	}

	return $rows;
}
