<?php
/**
* @version $Id: account.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class MMSBlogControllerAccount extends MMSBlogController
{

	function __construct()
	{
		parent::__construct( );

		$this->registerTask( 'add', 'edit' );
		$this->registerTask( 'apply', 'save' );
	}

	function edit()
	{
		JRequest::setVar( 'view', 'account' );
		JRequest::setVar( 'hidemainmenu', '1' );

		parent::display();
	}

	function remove()
	{
		$cid 	= JRequest::getVar('cid', array(), 'post', 'array');

		if (!is_array($cid) || count($cid) < 1)
		{
			echo "<script> alert('". JText::_( 'Select an item to remove' ) ."'); window.history.go(-1);</script>\n";
			exit;
		}

		$model = $this->getModel('account');
		if ($model->delete($cid)) {
			$msg = JText::sprintf( 'Accounts Deleted', count($cid) );
		} else {
			$msg = JText::_('Error Deleting Accounts');
		}

		$this->setRedirect('index.php?option=com_mmsblog&view=accounts', $msg);
	}

	function save()
	{
		$post = JRequest::get('post');
		$cid  = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int)$cid[0];

		if (is_array( $post['params'] ))
		{
			$registry = new JRegistry();
			$registry->loadArray($post['params']);
			$post['params'] = $registry->toString();
		}

		$model = $this->getModel('account');
		if ($model->store($post)) {
			$msg = JText::_('Account Saved');
		} else {
			$msg = JText::_('Error Saving Account');
		}

		switch (JRequest::getCmd('task'))
		{
			case 'apply':
				$link = 'index.php?option=com_mmsblog&task=edit&controller=account&cid[]='. $post['id'];
				break;

			case 'save':
			default:
				$link = 'index.php?option=com_mmsblog&view=accounts';
				break;
		}

		$this->setRedirect($link, $msg);
	}

	function publish()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1) {
			echo "<script> alert('". JText::_( 'Select an item to publish' ) ."'); window.history.go(-1);</script>\n";
			exit;
		}

		$model = $this->getModel('account');
		if(!$model->publish($cid, 1)) {
			$msg = $model->getError();
		} else {
			$msg = JText::sprintf( 'Accounts Published', count($cid) );
		}

		$this->setRedirect('index.php?option=com_mmsblog&view=accounts', $msg);
	}

	function unpublish()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1) {
			echo "<script> alert('". JText::_( 'Select an item to unpublish' ) ."'); window.history.go(-1);</script>\n";
			exit;
		}

		$model = $this->getModel('account');
		if(!$model->publish($cid, 0)) {
			$msg = $model->getError();
		} else {
			$msg = JText::sprintf( 'Accounts Unpublished', count($cid) );
		}

		$this->setRedirect('index.php?option=com_mmsblog&view=accounts', $msg);
	}

	function activate()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1) {
			echo "<script> alert('". JText::_( 'Select an item to activate' ) ."'); window.history.go(-1);</script>\n";
			exit;
		}

		$model = $this->getModel('account');
		if(!$model->activate($cid, 1)) {
			$msg = $model->getError();
		} else {
			$msg = JText::sprintf( 'Accounts Activated', count($cid) );
		}

		$this->setRedirect('index.php?option=com_mmsblog&view=accounts', $msg);
	}

	function deactivate()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1) {
			echo "<script> alert('". JText::_( 'Select an item to deactivate' ) ."'); window.history.go(-1);</script>\n";
			exit;
		}

		$model = $this->getModel('account');
		if(!$model->activate($cid, 0)) {
			$msg = $model->getError();
		} else {
			$msg = JText::sprintf( 'Accounts Deactivated', count($cid) );
		}

		$this->setRedirect('index.php?option=com_mmsblog&view=accounts', $msg);
	}

	function cancel()
	{
		$this->setRedirect('index.php?option=com_mmsblog&view=accounts');
	}
}
