<?php
/**
* @version $Id: item.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class MMSBlogControllerItem extends MMSBlogController {

	function __construct()
	{
		parent::__construct( );

		$this->registerTask( 'add', 'edit');
		$this->registerTask( 'apply', 'save' );
	}

	function edit()
	{
		JRequest::setVar( 'view', 'item' );
		JRequest::setVar( 'hidemainmenu', '1' );

		parent::display();
	}

	function save()
	{
		$post = JRequest::get('post');
		$cid  = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int)$cid[0];
		$post['content'] = JRequest::getVar('content', '', 'post', 'string', JREQUEST_ALLOWRAW);

		$model =& $this->getModel('item');
		if ($model->store($post)) {
			$msg = JText::_('Content Saved');
		} else {
			$msg = JText::_('Error Saving Content');
		}

		$mediaid        = JRequest::getVar('mediaid',        array(), 'post', 'array');
		$medianame      = JRequest::getVar('medianame',      array(), 'post', 'array');
		$mediapublished = JRequest::getVar('mediapublished', array(), 'post', 'array');
		$mediaordering  = JRequest::getVar('mediaordering',  array(), 'post', 'array');

		$model =& $this->getModel('media');
		$model->saveFromMessage($mediaid, $medianame, $mediapublished, $mediaordering);

		switch (JRequest::getCmd('task'))
		{
			case 'apply':
				$link = 'index.php?option=com_mmsblog&task=edit&controller=item&cid[]='. $post['id'];
				break;

			case 'save':
			default:
				$link = 'index.php?option=com_mmsblog&view=items';
				break;
		}

		$this->setRedirect($link, $msg);
	}

	function cancel()
	{
		$this->setRedirect('index.php?option=com_mmsblog&view=items');
	}

	function remove()
	{
		$cid 	= JRequest::getVar('cid', array(), 'post', 'array');

		if (!is_array($cid) || count($cid) < 1)
		{
			echo "<script> alert('". JText::_( 'Select an item to remove' ) ."'); window.history.go(-1);</script>\n";
			exit;
		}

		$model = $this->getModel('media');
		$model->deleteFromMessage($cid);

		$model = $this->getModel('item');
		if ($model->delete($cid)) {
			$msg = JText::sprintf('Content Deleted', count($cid));
		} else {
			$msg = JText::_('Error Deleting Content');
		}

		$this->setRedirect('index.php?option=com_mmsblog&view=items', $msg);
	}

	function publish()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1)
		{
			echo "<script> alert('". JText::_( 'Select an item to publish' ) ."'); window.history.go(-1);</script>\n";
			exit;
		}

		$model = $this->getModel('item');
		if(!$model->publish($cid, 1)) {
			$msg = $model->getError();
		} else {
			$msg = JText::sprintf('Content Published', count($cid) );
		}

		$this->setRedirect( 'index.php?option=com_mmsblog&view=items', $msg );
	}

	function unpublish()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1)
		{
			echo "<script> alert('". JText::_( 'Select an item to unpublish' ) ."'); window.history.go(-1);</script>\n";
			exit;
		}

		$model = $this->getModel('item');
		if(!$model->publish($cid, 0)) {
			$msg = $model->getError();
		} else {
			$msg = JText::sprintf('Content Unpublished', count($cid) );
		}

		$this->setRedirect( 'index.php?option=com_mmsblog&view=items', $msg );
	}

	function saveorder()
	{
		$cid   = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order = JRequest::getVar( 'order', array(0), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('item');
		$model->saveorder($cid, $order);

		$msg = 'New ordering saved';
		$this->setRedirect( 'index.php?option=com_mmsblog&view=items', JText::_($msg) );
	}

	function orderup()
	{
		$model = $this->getModel('item');
		$model->move(1);

		$this->setRedirect( 'index.php?option=com_mmsblog&view=items');
	}

	function orderdown()
	{
		$model = $this->getModel('item');
		$model->move(-1);

		$this->setRedirect( 'index.php?option=com_mmsblog&view=item&view=items');
	}
}
