<?php
/**
* @version $Id: user.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class MMSBlogControllerUser extends MMSBlogController
{

	function __construct()
	{
		parent::__construct( );

		$this->registerTask( 'add', 'edit' );
		$this->registerTask( 'apply', 'save' );
	}

	function remove()
	{
		$cid 	= JRequest::getVar('cid', array(), 'post', 'array');

		if (!is_array($cid) || count($cid) < 1)
		{
			echo "<script> alert('". JText::_( 'Select an item to remove' ) ."'); window.history.go(-1);</script>\n";
			exit;
		}

		$model = $this->getModel('user');
		if ($model->delete($cid)) {
			$msg = JText::sprintf('Users Deleted', count($cid));
		} else {
			$msg = JText::_('Error Deleting Users').': '.$model->getError();
		}

		$this->setRedirect('index.php?option=com_mmsblog&view=users', $msg);
	}


	function save()
	{
		$post = JRequest::get('post');
		$cid  = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int)$cid[0];
		$post['addresses'] = JRequest::getVar('addresses', '', 'post', 'string', JREQUEST_ALLOWRAW);

		$model = $this->getModel('user');

		if ($model->store($post)) {
			$msg = JText::_('User Saved');
		} else {
			$msg = JText::_('Error Saving User');
		}

		switch (JRequest::getCmd('task'))
		{
			case 'apply':
				$link = 'index.php?option=com_mmsblog&task=edit&controller=user&cid[]='. $post['id'];
				break;

			case 'save':
			default:
				$link = 'index.php?option=com_mmsblog&view=users';
				break;
		}

		$this->setRedirect($link, $msg);
	}

	function cancel()
	{
		$this->setRedirect( 'index.php?option=com_mmsblog&view=users' );
	}

	function edit()
	{
		JRequest::setVar( 'view', 'user' );
		JRequest::setVar( 'hidemainmenu', '1' );

		parent::display();
	}

	function publish()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1) {
			echo "<script> alert('". JText::_( 'Select an item to publish' ) ."'); window.history.go(-1);</script>\n";
			exit;
		}

		$model = $this->getModel('user');
		if(!$model->publish($cid, 1)) {
			$msg = $model->getError();
		} else {
			$msg = sprintf( JText::_( 'Users Published' ), count($cid) );
		}

		$this->setRedirect( 'index.php?option=com_mmsblog&view=users', $msg );
	}

	function unpublish()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1)
		{
			echo "<script> alert('". JText::_( 'Select an item to unpublish' ) ."'); window.history.go(-1);</script>\n";
			exit;
		}

		$model = $this->getModel('user');
		if(!$model->publish($cid, 0)) {
			$msg = $model->getError();
		} else {
			$msg = sprintf( JText::_( 'Users Unpublished' ), count($cid) );
		}

		$this->setRedirect( 'index.php?option=com_mmsblog&view=users', $msg );
	}
}
