<?php
/**
* @version $Id: install.mmsblog.php 257 2008-09-05 04:33:44Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

function com_install()
{
	_restorePreferences();

	_createSystemPlugin();
	_createSearchPlugin();
	_createLatestModule();
	_createLatestUsersModule();
	_createLatestImagesModule();
	_fixMenuItems();
}

function _restorePreferences()
{
	$db =& JFactory::getDBO();

	$query = 'SELECT content FROM #__mmsblog_item WHERE subject = '.$db->Quote('MMS BLOG PREFERENCES BACKUP');
	$db->setQuery($query);
	$params = $db->loadResult();
	if ($params)
	{
		$table =& JTable::getInstance('component');
		if ($table->loadByOption( 'com_mmsblog' ))
		{
			$table->params = $params;
			$table->store();
		}
	}

	$query = 'DELETE FROM #__mmsblog_item WHERE subject = '.$db->Quote('MMS BLOG PREFERENCES BACKUP');
	$db->setQuery($query);
	$db->query();
}

function _fixMenuItems()
{
	$db =& JFactory::getDBO();

	$query = 'SELECT c.id FROM #__components c WHERE c.parent=0 AND c.option=\'com_mmsblog\'';
	$db->setQuery($query);
	$id = $db->loadResult();

	$query = 'UPDATE #__menu SET componentid='.(int)$id
	. ' WHERE link LIKE \'index.php?option=com_mmsblog%\''
	. ' AND type=\'component\'';
	$db->setQuery($query);
	$db->query();
}

function _createLatestModule()
{
	$dst = JPATH_SITE.DS.'modules'.DS.'mod_mmsblog';
	$src = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_mmsblog'.DS.'assets'.DS.'modules'.DS.'mod_mmsblog';

	jimport('joomla.filesystem.folder');
	JFolder::copy($src, $dst, '', true);
}

function _createLatestUsersModule()
{
	$dst = JPATH_SITE.DS.'modules'.DS.'mod_mmsblog_users';
	$src = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_mmsblog'.DS.'assets'.DS.'modules'.DS.'mod_mmsblog_users';

	jimport('joomla.filesystem.folder');
	JFolder::copy($src, $dst, '', true);
}

function _createLatestImagesModule()
{
	$dst = JPATH_SITE.DS.'modules'.DS.'mod_mmsblog_images';
	$src = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_mmsblog'.DS.'assets'.DS.'modules'.DS.'mod_mmsblog_images';

	jimport('joomla.filesystem.folder');
	JFolder::copy($src, $dst, '', true);
}

function _createSearchPlugin()
{
	// remove existing plugin
	$db =& JFactory::getDBO();
	$query = "DELETE FROM #__plugins WHERE element='mmsblog' AND folder='search'";
	$db->setQuery($query);
	$db->query();

	$dest = JPATH_PLUGINS.DS.'search';
	$xml  = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_mmsblog'.DS.'assets'.DS.'plugins'.DS.'search'.DS.'mmsblog.xml';
	$php  = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_mmsblog'.DS.'assets'.DS.'plugins'.DS.'search'.DS.'mmsblog.php';

	jimport('joomla.filesystem.file');

	// copy files
	if (JFile::copy($xml, $dest.DS.'mmsblog.xml') && JFile::copy($php, $dest.DS.'mmsblog.php'))
	{
		// create the plugin in db
		$plugin = JTable::getInstance('plugin');

		$plugin->name      = 'Search - MMS Blog Cron';
		$plugin->element   = 'mmsblog';
		$plugin->folder    = 'search';
		$plugin->access    = 0;
		$plugin->ordering  = 100;
		$plugin->published = 1;
		$plugin->iscore    = 0;

		$plugin->store();
	}
}

function _createSystemPlugin()
{
	// remove existing plugin
	$db =& JFactory::getDBO();
	$query = "DELETE FROM #__plugins WHERE element='mmsblog' AND folder='system'";
	$db->setQuery($query);
	$db->query();

	$dest = JPATH_PLUGINS.DS.'system';
	$xml  = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_mmsblog'.DS.'assets'.DS.'plugins'.DS.'system'.DS.'mmsblog.xml';
	$php  = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_mmsblog'.DS.'assets'.DS.'plugins'.DS.'system'.DS.'mmsblog.php';

	jimport('joomla.filesystem.file');

	// copy files
	if (JFile::copy($xml, $dest.DS.'mmsblog.xml') && JFile::copy($php, $dest.DS.'mmsblog.php'))
	{
		// create the plugin in db
		$plugin = JTable::getInstance('plugin');

		$plugin->name      = 'System - MMS Blog Cron';
		$plugin->element   = 'mmsblog';
		$plugin->folder    = 'system';
		$plugin->access    = 0;
		$plugin->ordering  = 100;
		$plugin->published = 1;
		$plugin->iscore    = 0;

		$plugin->store();
	}
}
