-- @version $Id: install.utf.sql 247 2008-09-02 09:46:59Z jenscski $
-- @package MMS Blog
-- @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
-- @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

--
-- Definition of table `#__mmsblog_account`
--

CREATE TABLE IF NOT EXISTS `#__mmsblog_account` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(45) NOT NULL default '',
  `published` tinyint(1) unsigned NOT NULL default '0',
  `updated` int(10) unsigned NOT NULL default '0',
  `session_id` varchar(85) NOT NULL,
  `interval` tinyint(3) unsigned NOT NULL default '0',
  `category` int(10) unsigned NOT NULL default '0',
  `lastchecked` int(10) unsigned NOT NULL default '0',
  `params` text NOT NULL,
  `active` tinyint(1) unsigned NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `idx_name` (`name`)
) TYPE=MyISAM CHARACTER SET `utf8`;


--
-- Definition of table `#__mmsblog_item`
--

CREATE TABLE IF NOT EXISTS `#__mmsblog_item` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `subject` varchar(85) character set utf8 NOT NULL,
  `hash` varchar(32) character set utf8 NOT NULL,
  `uid` int(10) unsigned NOT NULL default '0',
  `address` varchar(85) NOT NULL,
  `content` text NOT NULL,
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `published` tinyint(1) unsigned NOT NULL default '0',
  `ordering` int(10) unsigned NOT NULL default '0',
  `category` int(10) unsigned NOT NULL default '0',
  `account` int(10) unsigned NOT NULL default '0',
  `alias` varchar(85) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `idx_published` (`published`),
  KEY `idx_ordering` (`ordering`)
) TYPE=MyISAM CHARACTER SET `utf8`;


--
-- Definition of table `#__mmsblog_media`
--

CREATE TABLE IF NOT EXISTS `#__mmsblog_media` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `msgid` int(10) unsigned NOT NULL,
  `filename` varchar(40) NOT NULL,
  `type` varchar(10) NOT NULL,
  `subtype` varchar(10) NOT NULL,
  `ordering` int(10) unsigned NOT NULL,
  `published` tinyint(1) unsigned NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `idx_published` (`published`),
  KEY `idx_ordering` (`ordering`)
) TYPE=MyISAM CHARACTER SET `utf8`;


--
-- Definition of table `#__mmsblog_user`
--

CREATE TABLE IF NOT EXISTS `#__mmsblog_user` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(85) NOT NULL,
  `addresses` text NOT NULL,
  `published` tinyint(1) unsigned NOT NULL default '0',
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `auto_publish` tinyint(1) unsigned NOT NULL default '0',
  `category` int(10) unsigned NOT NULL default '0',
  `juid` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `idx_published` (`published`)
) TYPE=MyISAM CHARACTER SET `utf8`;