<?php
/**
* @version $Id: account.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


jimport( 'joomla.application.component.model' );

class MMSBlogModelAccount extends JModel {

	var $_id   = null;
	var $_data = null;

	function __construct()
	{
		parent::__construct( );

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}

	function &getParams()
	{
		$path	= JPATH_ADMINISTRATOR.DS.'components'.DS.'com_mmsblog'.DS.'models'.DS.'account.xml';
		$params = new JParameter( $this->_data->params, $path );

		return $params;
	}

	function delete($cid = array())
	{
		if (count($cid))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode(',', $cid);

			$query = "DELETE FROM #__mmsblog_account WHERE id IN ($cids)";
			$this->_db->setQuery($query);
			if (!$this->_db->query())
			{
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

	function store(&$data)
	{
		// fetch a new empty row
		$row =& $this->getTable('mmsaccount');

		// bind the data
		#if (!$row->bind($data))
		if (!$row->bind($data))
		{
			$this->setError($row->getError());
			return false;
		}

		// check the data
		if (!$row->check())
		{
			$this->setError($row->getError());
			return false;
		}

		// store the data
		if (!$row->store())
		{
			$this->setError($this->getError());
			return false;
		}

		$data['id'] = $row->id;

		return true;
	}

	function setId($id) {
		$this->_id   = $id;
		$this->_data = null;
	}

	function &getData()
	{
		if (empty($this->_data)) {
			$this->_data =& $this->getTable('mmsaccount');
			if ($this->_id) {
				$this->_data->load( $this->_id );
			}

			// if new user, set publshed to true
			if (!$this->_id)
			{
				$this->_data->set('published', 1);
				$this->_data->set('interval', 5);
				$this->_data->set('active', 1);
			}

		}

		return $this->_data;
	}

	function publish( $cid, $publish )
	{
		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );

			$query = "UPDATE #__mmsblog_account"
			. "\n SET published = " . intval( $publish )
			. "\n WHERE id IN ( $cids )"
			;

			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

	function activate( $cid, $publish )
	{
		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );

			$query = "UPDATE #__mmsblog_account"
			. "\n SET active = " . intval( $publish )
			. "\n WHERE id IN ( $cids )"
			;

			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

}

?>
