<?php
/**
* @version $Id: item.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


jimport( 'joomla.application.component.helper' );
jimport( 'joomla.application.component.model' );

class MMSBlogModelItem extends JModel
{

	var $_id   = null;
	var $_data = null;

	function __construct()
	{
		parent::__construct( );

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}

	function getData() {
		if (empty($this->_data)) {
			$this->_data =& $this->getTable('mmsitem');
			if ($this->_id) {
				$this->_data->load( $this->_id );
			}

			// if new item, set publshed to true
			if (!$this->_id)
			{
				$this->_data->set('published', 1);
			}
		}

		return $this->_data;
	}

	function getMedia()
	{
		$query = 'SELECT * FROM #__mmsblog_media'
		. ' WHERE msgid='.(int)$this->_id
		. ' ORDER BY ordering';
		$this->_db->setQuery($query);
		$rows = $this->_db->loadObjectList();

		return $rows;
	}

	function store(&$data)
	{
		$row =& $this->getTable('mmsitem');

		// bind the data
		if (!$row->bind($data))
		{
			$this->setError($row->getError());
			return false;
		}

		// check the data
		if (!$row->check())
		{
			$this->setError($row->getError());
			return false;
		}

		// store the data
		if (!$row->store())
		{
			$this->setError($row->getError());
			return false;
		}

		$data['id'] = $row->id;

		return true;
	}

	function delete($cid = array())
	{
		if (count($cid))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode(',', $cid);

			$query = "DELETE FROM #__mmsblog_item WHERE id IN ($cids)";
			$this->_db->setQuery($query);
			if (!$this->_db->query())
			{
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}


	function publish( $cid, $publish )
	{
		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );

			$query = "UPDATE #__mmsblog_item"
			. "\n SET published = " . intval( $publish )
			. "\n WHERE id IN ( $cids )"
			;

			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

	function saveorder($cid = array(), $order)
	{
		$row =& $this->getTable('mmsitem');

		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		// update ordering values
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load($cid[$i]);

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		$row->reorder();

		return true;
	}

	function move($direction)
	{
		$row  =& $this->getTable('mmsitem');
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->move( $direction )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}

	function setId($id) {
		$this->_id   = $id;
		$this->_data = null;
	}
}

?>
