<?php
/**
* @version $Id: user.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


jimport( 'joomla.application.component.model' );

class MMSBlogModelUser extends JModel {

	var $_id   = null;
	var $_data = null;

	function __construct()
	{
		parent::__construct( );

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}

	function delete($cid = array())
	{
		if (count($cid))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode(',', $cid);
			$query = "SELECT COUNT(*) FROM #__mmsblog_item WHERE uid IN ($cids)";
			$this->_db->setQuery($query);
			$num = $this->_db->loadResult();
			if ($this->_db->getErrorNum()>0)
			{
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			if ($num>0)
			{
				$this->setError(JText::_('Users with posts cant be deleted'));
				return false;
			}

			$query = "DELETE FROM #__mmsblog_user WHERE id IN ($cids)";
			$this->_db->setQuery($query);
			if (!$this->_db->query())
			{
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

	function store(&$data)
	{
		// make the addresses to an usable format
		$addresses = $data['addresses'];
		$addresses = str_replace("\r", "\n", $addresses);
		$addresses = str_replace("\n\n", "\n", $addresses);
		$addresses = explode("\n", $addresses);

		$n = count($addresses);
		for ($i=0; $i<$n; $i++) {
			$addresses[$i] = '--'.trim($addresses[$i]).'--';
		}
		$data['addresses'] = implode("\n", $addresses);

		// fetch a new empty row
		$row =& $this->getTable('mmsuser');

		// bind the data
		if (!$row->bind($data))
		{
			$this->setError($row->getError());
			return false;
		}

		// check the data
		if (!$row->check())
		{
			$this->setError($row->getError());
			return false;
		}

		// store the data
		if (!$row->store())
		{
			$this->setError($row->getError());
			return false;
		}

		$data['id'] = $row->id;

		return true;
	}

	function setId($id)
	{
		$this->_id   = $id;
		$this->_data = null;
	}

	function getData()
	{
		if (empty($this->_data)) {
			$this->_data =& $this->getTable('mmsuser');
			if ($this->_id) {
				$this->_data->load( $this->_id );
			}

			// if new user, set publshed to true
			if (!$this->_id)
			{
				$this->_data->set('published', 1);
			}

			// Remove the -- delimiters from addresses
			$addrs = explode("\n", $this->_data->addresses);
			$n = count($addrs);
			for ($i=0; $i<$n; $i++) {
				$addrs[$i] = trim(trim($addrs[$i]),'-');
			}

			$this->_data->addresses = implode("\n", $addrs);
		}

		return $this->_data;
	}

	function checkin() {
		if ($this->_id) {
			$user =& $this->getTable('mmsbloguser');
			if (!$user->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}

		return false;
	}

	function checkout($uid = null) {
		if ($this->_id) {
			if (is_null($uid)) {
				$user =& JFactory::getUser();
				$uid  = $user->get('id');
			}

			$user =& $this->getTable('mmsbloguser');
			if (!$user->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}

		return false;
	}

	function publish( $cid, $publish )
	{
		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );

			$query = "UPDATE #__mmsblog_user"
			. "\n SET published = " . intval( $publish )
			. "\n WHERE id IN ( $cids )"
			;

			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

}

?>
