<?php
/**
* @version $Id: users.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


jimport( 'joomla.application.component.helper' );
jimport( 'joomla.application.component.model' );

class MMSBlogModelUsers extends JModel {

	var $_data = null;
	var $_total = null;
	var $_pagination = null;

	function __construct()
	{
		parent::__construct();

		global $mainframe;

		// Get the pagination request variables
		$limit		  = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( 'com_mmsblog.users.limitstart', 'limitstart', 0, 'int' );

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	function getData()
	{
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}

	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}

	function _buildQuery()
	{
		$where   = $this->_buildWhere();
		$orderby = $this->_buildOrderBy();

		$query = 'SELECT a.*, u.name AS juser,'
		. ' (SELECT count(*) FROM #__mmsblog_item m WHERE m.uid = a.id) AS posts'
		. ' FROM #__mmsblog_user AS a'
		. ' LEFT JOIN #__users u ON u.id = a.juid'
		. $where
		. $orderby
		;

		return $query;
	}

	function _buildWhere()
	{
		global $mainframe;

		$context    = 'com_mmsblog.users';
		$filter_state = $mainframe->getUserStateFromRequest( $context.'filter_state', 'filter_state', '', 'word' );
		$search       = $mainframe->getUserStateFromRequest( $context.'search',       'search',       '', 'string' );
		$search       = JString::strtolower( $search );

		$where = array();

		if ($search) {
			$where[] = '(LOWER(a.name) LIKE '.$this->_db->Quote('%'.$search.'%').' OR LOWER(a.addresses) LIKE '.$this->_db->Quote('%'.$search.'%').')';
		}

		if ($filter_state) {
			if ($filter_state == 'P') {
				$where[] = 'a.published = 1';
			} else if ($filter_state == 'U' ) {
				$where[] = 'a.published = 0';
			}
		}

		$where = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}

	function _buildOrderBy()
	{
		global $mainframe;

		$context          = 'com_mmsblog.users';
		$filter_order     = $mainframe->getUserStateFromRequest( $context.'filter_order',     'filter_order',     'a.name', 'cmd' );
		$filter_order_Dir = $mainframe->getUserStateFromRequest( $context.'filter_order_Dir', 'filter_order_Dir',	'',       'word' );

		$orderby = ' ORDER BY '.$filter_order.' '.$filter_order_Dir.', a.name';

		return $orderby;
	}

}
