<?php
/**
* @version $Id: uninstall.mmsblog.php 257 2008-09-05 04:33:44Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

function com_uninstall()
{
	_backupPreferences();

	_removeSystemPlugin();
	_removeSearchPlugin();
	_removeLatestModule();
	_removeLatestUsersModule();
	_removeLatestImagesModule();
}

function _backupPreferences()
{
	$component =& JComponentHelper::getComponent('com_mmsblog');

	$db =& JFactory::getDBO();

	$query = 'DELETE FROM #__mmsblog_item WHERE subject = '.$db->Quote('MMS BLOG PREFERENCES BACKUP');
	$db->setQuery($query);
	$db->query();

	$query = 'INSERT INTO #__mmsblog_item (subject, content) VALUES'
	. ' ('.$db->Quote('MMS BLOG PREFERENCES BACKUP')
	. ', '.$db->Quote($component->params)
	. ')';

	$db->setQuery($query);
	$db->query();
}

function _removeSystemPlugin()
{
	// remove existing plugin
	$db =& JFactory::getDBO();
	$query = "DELETE FROM #__plugins WHERE element='mmsblog' AND folder='system'";
	$db->setQuery($query);
	$db->query();

	$xml  = JPATH_PLUGINS.DS.'system'.DS.'mmsblog.xml';
	$php  = JPATH_PLUGINS.DS.'system'.DS.'mmsblog.php';

	jimport('joomla.filesystem.file');
	if (JFile::exists($xml)) {
		JFile::delete($xml);
	}
	if (JFile::exists($php)) {
		JFile::delete($php);
	}
}

function _removeSearchPlugin()
{
	// remove existing plugin
	$db =& JFactory::getDBO();
	$query = "DELETE FROM #__plugins WHERE element='mmsblog' AND folder='search'";
	$db->setQuery($query);
	$db->query();

	$xml  = JPATH_PLUGINS.DS.'search'.DS.'mmsblog.xml';
	$php  = JPATH_PLUGINS.DS.'search'.DS.'mmsblog.php';

	jimport('joomla.filesystem.file');
	if (JFile::exists($xml)) {
		JFile::delete($xml);
	}
	if (JFile::exists($php)) {
		JFile::delete($php);
	}
}

function _removeLatestModule()
{
	$db =& JFactory::getDBO();
	$query = "SELECT id FROM #__modules WHERE module='mod_mmsblog'";
	$db->setQuery($query);
	$cids = $db->loadResultArray();

	if (count($cids))
	{
		JArrayHelper::toInteger($cids);
		$cids = implode(', ', $cids);

		$query = 'DELETE FROM #__modules_menu WHERE moduleid IN ('.$cids.')';
		$db->setQuery($query);
		$db->query();

		$query = 'DELETE FROM #__modules WHERE id IN ('.$cids.')';
		$db->setQuery($query);
		$db->query();
	}

	$src = JPATH_SITE.DS.'modules'.DS.'mod_mmsblog';

	jimport('joomla.filesystem.folder');
	if (JFolder::exists($src)) {
		JFolder::delete($src);
	}
}

function _removeLatestUsersModule()
{
	$db =& JFactory::getDBO();
	$query = "SELECT id FROM #__modules WHERE module='mod_mmsblog_users'";
	$db->setQuery($query);
	$cids = $db->loadResultArray();

	if (count($cids))
	{
		JArrayHelper::toInteger($cids);
		$cids = implode(', ', $cids);

		$query = 'DELETE FROM #__modules_menu WHERE moduleid IN ('.$cids.')';
		$db->setQuery($query);
		$db->query();

		$query = 'DELETE FROM #__modules WHERE id IN ('.$cids.')';
		$db->setQuery($query);
		$db->query();
	}

	$src = JPATH_SITE.DS.'modules'.DS.'mod_mmsblog_users';

	jimport('joomla.filesystem.folder');
	if (JFolder::exists($src)) {
		JFolder::delete($src);
	}
}

function _removeLatestImagesModule()
{
	$db =& JFactory::getDBO();
	$query = "SELECT id FROM #__modules WHERE module='mod_mmsblog_images'";
	$db->setQuery($query);
	$cids = $db->loadResultArray();

	if (count($cids))
	{
		JArrayHelper::toInteger($cids);
		$cids = implode(', ', $cids);

		$query = 'DELETE FROM #__modules_menu WHERE moduleid IN ('.$cids.')';
		$db->setQuery($query);
		$db->query();

		$query = 'DELETE FROM #__modules WHERE id IN ('.$cids.')';
		$db->setQuery($query);
		$db->query();
	}

	$src = JPATH_SITE.DS.'modules'.DS.'mod_mmsblog_images';

	jimport('joomla.filesystem.folder');
	if (JFolder::exists($src)) {
		JFolder::delete($src);
	}
}
