<?php
/**
* @version $Id: view.html.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.view');
jimport('joomla.filter.output');

class MMSBlogViewItem extends JView
{

	function display()
	{
		$lists = array();

		$row   =& $this->get('data');
		$isNew = ($row->id < 1);

		$text = $isNew ? JText::_( 'New' ) : JText::_( 'Edit' );
		JToolBarHelper::title(   JText::_( 'MMS Blog Content' ).': <small><small>[ ' . $text.' ]</small></small>', 'addedit' );
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}

		$lists['published']   = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $row->published );
		$lists['category']    = JHTML::_('list.category', 'category', 'com_mmsblog', $row->category, null, 'title' );
		$lists['user']        = $this->_getUsers($row->uid);
		$lists['account']     = $this->_getAccounts($row->account);

		$editor =& JFactory::getEditor();

    JFilterOutput::objectHTMLSafe( $row );

    $media =& $this->get('media');

		$this->assignRef( 'row', $row );
		$this->assignRef( 'lists', $lists );
		$this->assignRef( 'editor', $editor );
		$this->assignRef( 'media', $media );

		parent::display( );
	}

	function _getAccounts($filter_account)
	{
		$db =& JFactory::getDBO();
		$users[] = JHTML::_('select.option', '0', '- '.JText::_('Select Account').' -', 'id', 'name');
		$db->setQuery('SELECT id, name FROM #__mmsblog_account ORDER BY name');
		foreach ($db->loadObjectList() as $row)
		{
			JFilterOutput::objectHTMLSafe( $row );
			$users[] = $row;
		}
		$users = JHTMLSelect::genericList( $users, 'account', '', 'id', 'name', $filter_account );

		return $users;
	}

	function _getUsers($filter_user)
	{
		$db =& JFactory::getDBO();
		$users[] = JHTML::_('select.option', '0', '- '.JText::_('Select Author').' -', 'id', 'name');
		$db->setQuery('SELECT id, name FROM #__mmsblog_user ORDER BY name');
		foreach ($db->loadObjectList() as $row)
		{
			JFilterOutput::objectHTMLSafe( $row );
			$users[] = $row;
		}
		$users = JHTMLSelect::genericList( $users, 'uid', '', 'id', 'name', $filter_user );

		return $users;
	}


}

