<?php
/**
* @version $Id: view.html.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.view');
jimport('joomla.filter.output');

class MMSBlogViewItems extends JView {

	function display() {
		global $mainframe;

		JToolBarHelper::title( JText::_('MMS Blog Content'), 'addedit' );
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNew();
		$bar = & JToolBar::getInstance('toolbar');
		$bar->appendButton( 'Popup', 'config', 'Preferences', 'index.php?option=com_mmsblog&amp;controller=config', 570, 470 );
		MMSBlogController::help('http://mms.pipp.no/doku.php/mmsblog/help/content');

		$db  =& JFactory::getDBO();
		$uri =& JFactory::getURI();

		$context          = 'com_mmsblog.items';
		$filter_user		  = $mainframe->getUserStateFromRequest($context.'filter_user',  		 'filter_user',      '0',          'int');
		$filter_state     = $mainframe->getUserStateFromRequest($context.'filter_state',		 'filter_state',     '',           'word');
		$filter_catid     = $mainframe->getUserStateFromRequest($context.'filter_catid',		 'filter_catid',     '',           'int');
		$filter_account   = $mainframe->getUserStateFromRequest($context.'filter_account',   'filter_account',   '',           'int');
		$filter_order		  = $mainframe->getUserStateFromRequest($context.'filter_order',		 'filter_order',     'g.ordering', 'cmd');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest($context.'filter_order_Dir', 'filter_order_Dir', 'desc',       'word');
		$search           = $mainframe->getUserStateFromRequest($context.'search',           'search',           '',           'string');
		$search           = htmlspecialchars(JString::strtolower( $search ));

		$rows =& $this->get('data');
		$page =& $this->get('pagination');

		// user filter
		$lists['users']	= $this->_getUsers($filter_user);

		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );

		// category filter
		$lists['category'] = JHTML::_('list.category', 'filter_catid', 'com_mmsblog', $filter_catid, 'onchange="submitform( );"', 'name' );

		// account filter
		$lists['account'] = $this->_getAccounts($filter_account);

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter
		$lists['search']= $search;


		$this->assignRef( 'rows', $rows );
		$this->assignRef( 'page', $page );
		$this->assignRef( 'lists', $lists );
		$this->assignRef('request_url',	JFilterOutput::ampReplace($uri->toString()));

		parent::display( );
	}

	function _getAccounts($filter_account)
	{
		$db =& JFactory::getDBO();
		$accounts[] = JHTML::_('select.option', '0', '- '.JText::_('Select Account').' -', 'id', 'name');
		$db->setQuery('SELECT id, name FROM #__mmsblog_account ORDER BY name');
		foreach ($db->loadObjectList() as $row)
		{
			JFilterOutput::objectHTMLSafe( $row );
			$accounts[] = $row;
		}
		$javascript = 'onchange="document.adminForm.submit();"';
		$accounts = JHTMLSelect::genericList( $accounts, 'filter_account', $javascript, 'id', 'name', $filter_account );

		return $accounts;
	}

	function _getUsers($filter_user)
	{
		$db =& JFactory::getDBO();
		$users[] = JHTML::_('select.option', '0', '- '.JText::_('Select Author').' -', 'id', 'name');
		$db->setQuery('SELECT id, name FROM #__mmsblog_user ORDER BY name');
		foreach ($db->loadObjectList() as $row)
		{
			JFilterOutput::objectHTMLSafe( $row );
			$users[] = $row;
		}
		$javascript = 'onchange="document.adminForm.submit();"';
		$users = JHTMLSelect::genericList( $users, 'filter_user', $javascript, 'id', 'name', $filter_user );

		return $users;
	}
}

