<?php
/*
 *
 */

echo '<?xml version="1.0" encoding="utf-8" ?>';
echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
echo '<html xmlns="http://www.w3.org/1999/xhtml" dir="ltr">';
echo '<head>';
echo '<meta http-equiv="Content-Type" content="text/html;  charset=UTF-8" />';
echo '<title>Joomla! - INI-file checker</title>';
echo '</head>';
echo '<body>';

$files = array('.com_mmsblog.ini', '.com_mmsblog.menu.ini', '.mod_mmsblog.ini', '.mod_mmsblog_users.ini', '.mod_mmsblog_images.ini');
$langs = array('nb-NO', 'sv-SE', 'de-DE');

echo '<table width="100%" border="0">';

foreach ($files as $file)
{
	foreach ($langs as $lang)
	{
		echo '<tr><td style="border: 1px black solid" colspan=4><span style="font-size: large;">'.$lang.$file.'</span></td></tr>';
		check_file($file, $lang);
		echo '<tr><td colspan=4><span style="font-size: large;"><br/></span></td></tr>';
	}
}

echo '</table>';
echo '</body>';
echo '</html>';


function check_file( $file, $lang )
{
	$lines_eng = file( "en-GB$file" );
	$lines_lng = file( "$lang$file" );

	$definitions_eng = array();
	$definitions_lng = array();
	$definitions = array();


	foreach( $lines_lng as $lnum => $line ) {
		$line = trim($line);
		if( (preg_match( '/^#/', $line ) == false) & (preg_match('/=..*/', $line) == true) ) {
			$parts = split('=', $line, 2);

			//$parts[0] = str_replace('&', '_', $parts[0]);
			//$parts[0] = str_replace('"', '-', $parts[0]);
			//$parts[0] = str_replace('>', '-', $parts[0]);
			$parts[0] = htmlentities(strtoupper($parts[0]));

			$definitions_lng[$parts[0]] = $parts[1];
			$lines_lng[$parts[0]] = ($lnum + 1);
			$definitions[] = $parts[0];
		}
	}

	foreach( $lines_eng as $line ) {
		$line = trim($line);
		if( (preg_match( '/^#/', $line ) == false) & (preg_match('/=..*/', $line) == true) ) {
			$parts = split('=', $line, 2);

			//$parts[0] = str_replace('&', '_', $parts[0]);
			//$parts[0] = str_replace('"', '-', $parts[0]);
			//$parts[0] = str_replace('>', '-', $parts[0]);
			$parts[0] = htmlentities(strtoupper($parts[0]));

			$definitions_eng[$parts[0]] = $parts[1];
			$definitions[] = $parts[0];
		}
	}

	$definitions = array_unique( $definitions );
	sort( $definitions );

	foreach( $definitions as $def ) {
		//$def = htmlentities( $def );

		if( !array_key_exists( $def, $definitions_eng ) ) {
			echo "<tr style=\"background-color: #dddddd;\">\n";
			echo "  <td width=\"10\">".$lines_lng[$def]."</td>\n";
			echo "  <td style=\"font-size: 110%;\">$def</td>\n";
			echo "  <td colspan=2 style=\"color: red;\">Deprecated</td>\n";
			echo "</tr>\n";
		} elseif( !array_key_exists( $def, $definitions_lng ) ) {
			echo '<tr style="background-color: #dddddd;">';
			echo '  <td width="10"></td>';
			echo '  <td style="font-size: 110%;">'.$def.'='.htmlspecialchars($definitions_eng[$def]).'</td>';
			echo '  <td colspan=2 style="color: red;">Missing</td>';
			echo '</tr>';
		}
	}
}
