<?php
/**
* @version $Id: helper.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class MMSBlogHelper extends JObject
{
	function mediaPath($row = null)
	{
		$path = JPATH_SITE.DS.'images'.DS.'mmsblog'.DS;

		if ($row !== null) {
			$path .= sprintf('%05d_%05d.%s', $row->msgid, $row->id, strtolower(JFile::getExt($row->filename)));
		}

		return $path;
	}

	function mediaURL($row = null)
	{
		$url = JURI::root().'images/mmsblog/';

		if ($row !== null) {
			$url .= sprintf('%05d_%05d.%s', $row->msgid, $row->id, strtolower(JFile::getExt($row->filename)));
		}

		return $url;
	}

	function checkSystem()
	{
		global $mainframe;

		jimport('joomla.filesystem.folder');

		$return = true;

		$media = MMSBlogHelper::mediaPath();
		if (!JFolder::exists($media))
		{
			if (!JFolder::create($media))
			{
				MMSLog::_('- missing image folder');
				$media = str_replace(JPATH_SITE, '...', $media);
				$msg = JText::sprintf('MISSINGFOLDER', $media, 'http://mms.pipp.no/doku.php/mmsblog/help/folder');
				$mainframe->enqueueMessage($msg, 'error');
				$return = false;
			} else {
				jimport('joomla.filesystem.file');
				JFile::write($media.DS."index.html", "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>");
			}
		}

		if (!extension_loaded('imap'))
		{
			MMSLog::_('- missing imap');
			$msg = JText::sprintf('MISSINGIMAP', 'http://mms.pipp.no/doku.php/mmsblog/help/imap');
			$mainframe->enqueueMessage($msg, 'error');
			$return = false;
		}

		if (!extension_loaded('iconv'))
		{
			MMSLog::_('- missing iconv');
			$msg = JText::sprintf('MISSINGICONV', 'http://mms.pipp.no/doku.php/mmsblog/help/iconv');
			$mainframe->enqueueMessage($msg, 'error');
			$return = false;
		}

		return $return;
	}

	function &getUser($addr)
	{
		static $users;

		JTable::addIncludePath( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_mmsblog'.DS.'tables' );

		if (!isset($users)) {
			$users = array();
		}

		if (empty($users[$addr]))
		{
			# Try to find an existing user
			$db =& JFactory::getDBO();
			$query = 'SELECT m.id FROM #__mmsblog_user m'
			. ' WHERE m.addresses LIKE '.$db->Quote('%--'.$addr.'--%');
			$db->setQuery( $query );
			$id = $db->loadResult();
			if ($db->getErrorNum()) {
				JError::raiseError( 500, 'MMS Blog: ' . $db->errorMsg() );
				return;
			}

			# Load existing, or create new
			$user = JTable::getInstance( 'mmsuser', 'Table' );
			$user->id = (int)$id;
			if (!$user->load())
			{
				$query = 'SELECT u.id, u.name FROM #__users u WHERE u.email = '.$db->Quote($addr);
				$db->setQuery($query);
				$juser = $db->loadObject();
				$params =& JComponentHelper::getParams('com_mmsblog');
				$user->id           = null;
				$user->name         = is_null($juser) ? JText::_('Untitled User') : $juser->name;
				$user->juid         = is_null($juser) ? 0 : $juser->id;
				$user->addresses    = '--'.$addr.'--';
				$user->published    = (int)$params->get('publish_new_user', '0');
				$user->created      = gmdate('Y-m-d H:i:s');
				if (!$user->store()) {
					JError::raiseError( 500, 'MMS Blog: ' . $db->errorMsg() );
					return;
				}

				MMSLog::sprintf(' - added user: %s', $addr);

				MMSBlogHelper::newUserMail($user, $addr);
			}

			$users[$addr] = $user;
		}

		return $users[$addr];
	}

	function newUserMail(&$user, $addr)
	{
		$recipients = array();

		$params =& JComponentHelper::getParams('com_mmsblog');
		$email = $params->get('email', '');

		if (!empty($email)) {
			$recipients[] = $email;
		} else {
			$db =& JFactory::getDBO();
			$query = 'SELECT email FROM #__users WHERE gid=25 AND sendEmail=1';
			$db->setQuery($query);
			$rows = $db->loadObjectList();
			foreach ($rows as $row) {
				$recipients[] = $row->email;
			}
		}

		$url = JURI::root() . 'administrator/index.php?option=com_mmsblog&task=edit&controller=user&cid[]='.$user->id;

		$msg = JText::sprintf('NEWUSERMAIL', $user->name, $addr, $url);

		jimport('joomla.mail.helper');
		foreach ($recipients as $recipient)
		{
			$mail =& JFactory::getMailer();
			$mail->addRecipient($recipient);
			$mail->setSubject(JText::_('New MMS User'));
			$mail->setBody($msg);
			$mail->Send();
		}
	}
}

