<?php
/**
* @version $Id: route.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

// Component Helper
jimport('joomla.application.component.helper');

class MMSBlogHelperRoute
{
	/**
	 * The route of the mms blog users
	 */
	function getUsersRoute()
	{
		static $item;
		static $items;

		$default = null;
		$itemid  = null;

		if (!$item)
		{
			$menu =& JSite::getMenu();
			$item = $menu->getItems('link', 'index.php?option=com_mmsblog&view=users', true);
		}

		if ($item) {
			return 'index.php?option=com_mmsblog&Itemid='.$item->id;
		}

		// Get the menu items for this component.
		if (!$items)
		{
			$menu =& JSite::getMenu();
			$items = $menu->getItems('link', 'index.php?option=com_mmsblog&view=mmsblog');
		}

		if (is_array($items))
		{
			foreach ($items as $item)
			{
				$params = new JParameter($item->params);

				// check for default
				if (!$default && !$params->get('user') && !$params->get('account') && !$params->get('category')) {
					$default = $item;
				}
			}
		}

		//Create the link
		$link = 'index.php?option=com_mmsblog&task=users';

		if ($default) {
			$link .= '&Itemid='.$default->id;
		}

		return $link;
	}

	/**
	 * The route of the mms blog user
	 */
	function getUserRoute($user)
	{
		static $items;

		$itemid  = null;

		if (!$items)
		{
			$menu =& JSite::getMenu();
			$items = $menu->getItems('link', 'index.php?option=com_mmsblog&view=mmsblog');
		}

		if (is_array($items))
		{
			foreach ($items as $item)
			{
				$params = new JParameter($item->params);

				// check for default
				if (!$itemid && !$params->get('user') && !$params->get('account') && !$params->get('category')) {
					$itemid = $item;
				}
			}
		}

		//Create the link
		$link = 'index.php?option=com_mmsblog&view=user&id='.$user;

		if ($itemid) {
			$link .= '&Itemid='.$itemid->id;
		}

		return $link;
	}

	/**
	 * The route of the mms blog item
	 */
	function getItemRoute($id, $account, $user, $category)
	{
		static $items;

		$itemid  = null;
		$default = null;
		$points = 0;

		// Get the menu items for this component.
		if (!$items)
		{
			$menu =& JSite::getMenu();
			$items = $menu->getItems('link', 'index.php?option=com_mmsblog&view=mmsblog');
		}

		if (is_array($items))
		{
			foreach ($items as $item)
			{
				$params = new JParameter($item->params);

				// check for default
				if (!$default && !$params->get('user') && !$params->get('account') && !$params->get('category')) {
					$default = $item;
				}

				// check for a matching one
				$tmpPoints = 0;
				if ($account == $params->get('account')) {
					$tmpPoints++;
				}

				if ($user == $params->get('user')) {
					$tmpPoints++;
				}

				if ($category && $category == $params->get('category')) {
					$tmpPoints++;
				}

				if (!$itemid && $tmpPoints > $points)
				{
					if ($category == $params->get('category') || !$params->get('category'))
					{
						if ($user == $params->get('user') || !$params->get('user'))
						{
							if ($account == $params->get('account') || !$params->get('account'))
							{
								$points = $tmpPoints;
								$itemid = $item;
							}
						}
					}
				}
			}
		}

		$itemid = $itemid ? $itemid : $default;

		//Create the link
		$link = 'index.php?option=com_mmsblog&view=item&id='.$id;

		if ($itemid) {
			$link .= '&Itemid='.$itemid->id;
		}

		return $link;
	}
}
