<?php
/**
* @version $Id: mmsblog.php 255 2008-09-04 04:42:00Z jenscski $
* @package MMS Blog
* @copyright Copyright (C) 2006 - 2008 Jens-Christian Skibakk. All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class MMSBlogModelMMSBlog extends JModel
{
	var $_data = null;
	var $_total = null;
	var $_pagination = null;

	function __construct()
	{
		parent::__construct();

		$app =& JFactory::getApplication();
		$config =& $app->getParams('com_mmsblog');

		$this->setState('account',    $config->get('account', 0));
		$this->setState('category',   $config->get('category', 0));
		$this->setState('user',       $config->get('user', 0));
		$this->setState('limit',      $config->get('onpage', 5));
		$this->setState('limitstart', JRequest::getInt('limitstart', 0));

		$uid = JRequest::getInt('uid', 0);
		if ($uid) {
			$this->setState('user', $uid);
		}
	}

	function &getData()
	{
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data =& $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));

			$n = count($this->_data);
			for ($i=0; $i<$n; $i++) {
				$this->_data[$i]->media = & $this->_getList('SELECT m.* FROM #__mmsblog_media m WHERE m.msgid='.(int)$this->_data[$i]->id.' AND m.published = 1 ORDER BY m.ordering');
			}
		}

		return $this->_data;
	}

	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}

	function _buildQuery()
	{
		$where = $this->_buildWhere();
		$query = 'SELECT m.id, m.uid, m.account, m.subject, m.content, m.created, u.name AS author, c.title AS category,'
		. ' CASE WHEN CHAR_LENGTH(m.alias) THEN CONCAT_WS(":", m.id, m.alias) ELSE m.id END as slug'
		. ' FROM #__mmsblog_item AS m'
		. ' LEFT JOIN #__mmsblog_account AS a ON a.id = m.account'
		. ' LEFT JOIN #__mmsblog_user AS u ON u.id = m.uid'
		. ' LEFT JOIN #__categories AS c ON c.id = m.category'
		. ' WHERE m.published = 1'
		. ' AND a.published = 1'
		. ' AND u.published = 1'
		. ' AND (c.published = 1 OR c.published IS NULL)'
		. $where
		. ' ORDER BY m.ordering DESC';

		return $query;
	}

	function _buildWhere()
	{
		$category = (int) $this->getState('category');
		$account  = (int) $this->getState('account');
		$user     = (int) $this->getState('user');
		$juser    =& JFactory::getUser();

		$where = array();
		if ($category) {
			$where[] = 'm.category = '.$category;
		}
		if ($account) {
			$where[] = 'm.account = '.$account;
		}
		if ($user) {
			$where[] = 'm.uid = '.$user;
		}

		$where[] = '(c.access <= '.(int)$juser->get('aid', 0) . ' OR c.access IS NULL)';

		return count($where) ? (' AND ' . implode(' AND ', $where)) : '';;
	}
}
